%if 0%{?rhel} && 0%{?rhel} <= 6
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}
%else
%if 0%{?fedora}
%global with_python3 1
%endif
%endif

%global with_test 0

# This package installs two private shared libraries, don't 'provide' them
%if 0%{?with_python3}
%global __provides_exclude_from ^(%{python2_sitearch}/.*\\.so)$|%{python3_sitearch}/.*\\.so)$
%else
%global __provides_exclude_from ^(%{python2_sitearch}/.*\\.so)$
%endif

Name:           python-djvulibre
Version:        0.8
Release:        2%{?dist}
Summary:        Python bindings for the DjVuLibre library
Group:          Development/Libraries

License:        GPLv2
URL:            http://jwilk.net/software/python-djvulibre
Source0:        https://pypi.io/packages/source/p/%{name}/%{name}-%{version}.tar.gz

BuildRequires:  python2-devel djvulibre-libs djvulibre-devel Cython
BuildRequires:  python-docutils
BuildRequires:  python-nose

%if 0%{?rhel} && 0%{?rhel} <=6
# Use Sphinx10 on EL <= 6
BuildRequires:  python-sphinx10
# python-sphinx10 doesn't set sys.path correctly; do it for them
%global pythonpath %(find %{python2_sitelib} -name Sphinx*.egg)
%else
BuildRequires:  python-sphinx >= 1.0
%endif 

%global _description\
python-djvulibre is a set of Python bindings for the DjVuLibre library, an open\
source implementation of DjVu

%description %_description

%package -n python2-djvulibre
Summary: %summary
%{?python_provide:%python_provide python2-djvulibre}

%description -n python2-djvulibre %_description

%if 0%{?with_python3}

%package -n python3-djvulibre
Summary: %summary
%{?python_provide:%python_provide python3-djvulibre}

BuildRequires:  python3-devel
BuildRequires:  python3-Cython >= 0.20
BuildRequires:  python3-docutils
BuildRequires:  python3-nose

BuildRequires:  python3-sphinx >= 1.0

%description -n python3-djvulibre %_description

%endif

%package doc
Summary:        Documentation for python-djvulibre
Group:          Documentation
Buildarch:      noarch
Requires:       %{name} = %{version}-%{release}

%description doc
Documentation for python-djvulibre

%prep
%setup -q


%build
CFLAGS="$RPM_OPT_FLAGS" %{__python2} setup.py build
%{?pythonpath: PYTHONPATH="%{pythonpath}"} \
    %{__python2} setup.py build_sphinx

%if 0%{?with_python3}
CFLAGS="$RPM_OPT_FLAGS" %{__python3} setup.py build
%{?pythonpath: PYTHONPATH="%{pythonpath}"} \
    %{__python3} setup.py build_sphinx
%endif

# Fix wrong EOL markers in documentation
sed -i 's/\r$//' build/sphinx/html/_static/jquery.js
 
# Make sure scripts in the examples directory aren't executable
%{__chmod} 0644 examples/*

%install
%{__python2} setup.py install -O1 --skip-build --root %{buildroot}

# Fix non-standard (0775) executable permissions on private shared libraries
%{__chmod} 0755 %{buildroot}%{python2_sitearch}/djvu/sexpr.so
%{__chmod} 0755 %{buildroot}%{python2_sitearch}/djvu/decode.so

%if 0%{?with_python3}
%{__python3} setup.py install -O1 --skip-build --root %{buildroot}
# Fix non-standard (0775) executable permissions on private shared libraries
%{__chmod} 0755 %{buildroot}%{python3_sitearch}/djvu/sexpr.*.so
%{__chmod} 0755 %{buildroot}%{python3_sitearch}/djvu/decode.*.so
%endif

%if 0%{?with_test}
%check
LC_ALL='en_US.UTF-8' %{__python2} setup.py nosetests
%if 0%{?with_python3}
LC_ALL='en_US.UTF-8' %{__python3} setup.py nosetests
%endif
%endif

%files -n python2-djvulibre
# For arch-specific packages: sitearch
%doc doc/COPYING doc/changelog doc/credits.txt
%{python2_sitearch}/*

%if 0%{?with_python3}
%files -n python3-djvulibre
# For arch-specific packages: sitearch
%doc doc/COPYING doc/changelog doc/credits.txt
%{python3_sitearch}/*
%endif

%files doc
%doc build/sphinx/html/* examples

%changelog
* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 0.8-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Sun Sep  3 2017 Jan Beran <jberan@redhat.com> - 0.8-1
- New version including Python 3 subpackage

* Sat Aug 19 2017 Zbigniew Jędrzejewski-Szmek <zbyszek@in.waw.pl> - 0.3.9-11
- Python 2 binary package renamed to python2-djvulibre
  See https://fedoraproject.org/wiki/FinalizingFedoraSwitchtoPython3

* Thu Aug 03 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.9-10
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Binutils_Mass_Rebuild

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.9-9
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.9-8
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Tue Jul 19 2016 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3.9-7
- https://fedoraproject.org/wiki/Changes/Automatic_Provides_for_Python_RPM_Packages

* Thu Feb 04 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.3.9-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Thu Jun 18 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3.9-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Sun Aug 17 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.3.9-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Tue Jul 15 2014 Brian Stinson <bstinson@ksu.edu> - 0.3.9-3
- Change to using consistent buildroot tags, since DjVulibre isn't packaged for
  el5, we don't need to explicitly remove the buildroot in the install step
- Split out examples and documentation into a subpackage
- Add a check step to run nosetests

* Mon Jul 14 2014 Brian Stinson <bstinson@ksu.edu> - 0.3.9-2
- Incorporate suggested macro removals and changes from jduncan and cicku

* Sun Jul 13 2014 Brian Stinson <bstinson@ksu.edu> - 0.3.9-1
- Initial Build
